#include <math.h>
#include <stdlib.h>
#if defined(WIN32)
#  pragma warning(disable: 4996)
#  include "glew.h"
#  include "glut.h"
#  include "glext.h"
#elif defined(__APPLE__) || defined(MACOSX)
#  include <GLUT/glut.h>
#else
#  define GL_GLEXT_PROTOTYPES
#  include <GL/glut.h>
#endif

/* ĺХåե֥ȤΥ򻲾Ȥݥ󥿤Υǡ */
typedef GLfloat Texture[2];
typedef GLuint Face[3];

/*
** å򻰳ѷ
*/
GLuint solidMesh(int slices, int stacks, const GLuint *buffer)
{
  GLuint vertices = (slices + 1) * (stacks + 1);
  GLuint faces = slices * stacks * 2;

  /* ĺХåե֥Ȥͭˤ */
  glBindBuffer(GL_ARRAY_BUFFER, buffer[0]);
  glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, buffer[1]);

  /* ĺХåե֥Ȥ˥ΰݤ */
  glBufferData(GL_ARRAY_BUFFER, sizeof (Texture) * vertices, NULL, GL_STATIC_DRAW);
  glBufferData(GL_ELEMENT_ARRAY_BUFFER, sizeof (Face) * faces, NULL, GL_STATIC_DRAW);

  /* ĺХåե֥ȤΥץΥ֤˥ޥåפ */
  Texture *texture = (Texture *)glMapBuffer(GL_ARRAY_BUFFER, GL_WRITE_ONLY);
  Face *face = (Face *)glMapBuffer(GL_ELEMENT_ARRAY_BUFFER, GL_WRITE_ONLY);

  /* ĺΰ */
  for (int j = 0; j <= stacks; ++j) {
    float t = (float)j / (float)stacks;

    for (int i = 0; i <= slices; ++i) {
      float s = (float)i / (float)slices;

      (*texture)[0] = s;
      (*texture)[1] = t;
      ++texture;
    }
  }

  /* ̤λɸ */
  for (int j = 0; j < stacks; ++j) {
    for (int i = 0; i < slices; ++i) {
      int count = (slices + 1) * j + i;

      /* Ⱦʬ */
      (*face)[0] = count;
      (*face)[1] = count + 1;
      (*face)[2] = count + slices + 2;
      ++face;

      /* Ⱦʬ */
      (*face)[0] = count;
      (*face)[1] = count + slices + 2;
      (*face)[2] = count + slices + 1;
      ++face;
    }
  }

  /* ĺХåե֥ȤΥץΥ֤ڤΥ */
  glUnmapBuffer(GL_ELEMENT_ARRAY_BUFFER);
  glUnmapBuffer(GL_ARRAY_BUFFER);

  /* ĺХåե֥Ȥ */
  glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, 0);
  glBindBuffer(GL_ARRAY_BUFFER, 0);

  return faces * 3;
}
